//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 12-1
//
// Allows user to enter a string, then changes alll instances of "can't" to 
// "cannot" and all instances of "won't" to "will not" and output the new
// string.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>
#include <string.h>

#define SIZE 100

char* replace(char * str, char * orig, char * rep) {
   char buffer[SIZE];
   char * temp = str;
   char * p = str;
   
   p = strstr ( p, orig ) +  1;
   
   if ( p == 1 )
      return str;

   
   do {
      strncpy ( buffer, temp, p-temp - 1 );
      buffer[p - temp - 1] = '\0';
      
      sprintf ( buffer + ( p-temp - 1 ), "%s %s", rep, p + strlen ( orig ) );
      
      strcpy ( temp, buffer );
      
      p = strstr ( p, orig ) +  1;
   } while ( p != 1);

   
   return buffer;
}

void main(void) 
{
   char line[SIZE];
  
   for (;;)  {
      
      printf ("Ready for string\r\n\r\n");
      
      get_string_usb ( line, SIZE );
      
      strcpy ( line, replace( line, "won't", "will not" ));
      
      strcpy ( line, replace( line, "can't", "can not" ));
      
      printf("\r\n");
      
      puts ( line ) ;
   }
   
   for (;;);
}
